;; lfnload.asm -- lfnsrv loader
;; Copyright (C) 1999-2000 Andrew Crabtree, Wojciech Galazka
;; Modified parts Copyright (C) 2016 Joe Forster/STA
;;
;; Original code written by Andrew Crabtree, 1997-1999
;;
;; Code of strcpy procedure based on the code from
;;	The UCR Standard Library for Assembly Language Programmers
;;	Written By Randall Hyde and others
;;
;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program; if not, write to the Free Software Foundation,
;; Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
;;
;; This is the 16 bit DOS TSR portion of the Long File Name API on Windows NT
;; It will load the NT dll, hook Int 0x21, and then terminate and stay
;; resident Then it snoops int 21. Any LFN calls will be handled here, and
;; redirected to the DLL. Some calls need special processing in
;; both the DLL and here. Some non LFN calls are also processed
;;
;;  ";;"   marks comments
;;  ";;;;" means code that has been found unneccessary
;;
;; The code is not optimized, but it still fits well below 3 kB so who cares?
;; If you have any ideas how the 600 bytes buffer space can be used for
;; drop me a line
;;
		JUMPS

;; BOP Macros 	 from Microsoft NT DDK Include File ISVBOP.H
;;		See msdn.microsoft.com for a copy of NT 4.0 DDK
VDDRegister macro
	db 	0c4h,0c4h,058h,000h
endm

VDDDispatch macro
	db 	0c4h,0c4h,058h,002h
endm

VDDUnregister macro
	db 	0c4h,0c4h,058h,001h
endm

DISPLAY_STRING			EQU	9h
print	macro text
	mov 	ah,  DISPLAY_STRING
	mov 	dx, offset text
	int 	21h
endm

dispatchh macro what, where
	cmp	ah, what
	je	where
endm


dispatch macro what, where
	cmp	ax, what
	je	where
endm

call_vdd macro
.386
        shl 	eax, 16
.8086
        mov 	ax, [dllHandle]
        VDDDispatch
endm

DOS_INTR			EQU	  21h
BIOS_DISK_INTR			EQU	  13h
ABS_DISK_READ_INTR		EQU	  25h
ABS_DISK_WRITE_INTR		EQU	  26h

RESET_DRIVE			EQU	  0Dh
SET_DEFAULT_DRIVE               EQU       0Eh
GET_CURRENT_DRIVE		EQU	  19h
SET_INTERRUPT_VECTOR		EQU	  25h
GO_STAY_TSR			EQU	  31h
GET_TRUE_VERSION_NUMBER		EQU	3306h
GET_INTERRUPT_VECTOR		EQU	  35h
GET_DISK_FREE_SPACE		EQU	  36h
SET_CURRENT_DIRECTORY     	EQU       3Bh
W95_GET_COMPRESSED_FILE_SIZE	EQU	4302h
W95_EXT_LENGTH_FILENAME_OPERATIONS EQU	43FFh
W95_LOCK_DRIVE			EQU	440Dh
W95_LOCK_DRIVE_CATEG_DISK		EQU	08h
W95_LOCK_DRIVE_CATEG_FAT32_DISK		EQU	48h
W95_LOCK_DRIVE_MINOR_LOCK_LOGICAL	EQU	4Ah
W95_LOCK_DRIVE_MINOR_LOCK_PHYSICAL	EQU	4Bh
W95_LOCK_DRIVE_MINOR_UNLOCK_LOGICAL	EQU	6Ah
W95_LOCK_DRIVE_MINOR_UNLOCK_PHYSICAL	EQU	6Bh
W95_LOCK_DRIVE_MINOR_LOCK_GETFLAGS	EQU	6Ch
W95_LOCK_DRIVE_MINOR_LOCK_GETSTATE	EQU	70h
GET_CURRENT_DIRECTORY		EQU	  47h
FREE_ENVIRONM_MEMORY		EQU	  49h
TERMINATE_PROGRAM		EQU       4Ch
GET_SYSVARS_TABLE		EQU       52h
GET_CURRENT_PSP			EQU       62h
CREATE_OPEN_FILE		EQU	6C00h

GET_LAST_ACCESS_DATE		EQU	5704h
SET_LAST_ACCESS_DATE		EQU	5705h
GET_CREATION_DATE		EQU	5706h
SET_CREATION_DATE		EQU	5707h
LONG_RESET_DRIVE		EQU	710Dh
LONG_CREATE_DIRECTORY           EQU     7139h
LONG_REMOVE_DIRECTORY           EQU     713Ah
LONG_SET_CURRENT_DIRECTORY      EQU     713Bh
LONG_DELETE_FILE                EQU     7141h
LONG_GET_SET_FILE_ATTR          EQU     7143h
LONG_GET_CURRENT_DIRECTORY      EQU     7147h
LONG_FIND_FIRST                 EQU     714Eh
LONG_FIND_NEXT                  EQU     714Fh
LONG_RENAME_FILE                EQU     7156h
LONG_TRUENAME                   EQU     7160h
LONG_CREATE_FILE                EQU     716Ch
LONG_GET_VOLUME_INFORMATION     EQU     71A0h
LONG_FIND_CLOSE                	EQU	71A1h
LONG_FIND_NEXT_EXT              EQU	71A2h
LONG_RESERVED_1			EQU	71A3h
LONG_RESERVED_2                 EQU     71A4h
LONG_RESERVED_3                 EQU     71A5h
LONG_GET_FILE_INFORMATION       EQU     71A6h
LONG_CONVERT_TIME    	        EQU     71A7h
LONG_GENERATE_SHORT_NAME        EQU     71A8h
LONG_SERVER_CREATE_FILE         EQU     71A9h
LONG_HANDLE_SUBST               EQU     71AAh

LFNSRV_API			EQU	7171h
LFNSRV_GET_LOADER_INFO		EQU	0001h
LFNSRV_GET_VERSION_INFO         EQU	0001h
LFNSRV_SET_SFT_INFO		EQU	0003h

W95_GET_EXT_FREE_DRIVE_SPACE	EQU	7303h
W95_EXT_ABSOLUTE_DISK_READ_WRITE EQU	7305h

;;BDSK_RESET_DISKS		EQU	00h
;;BDSK_GET_LAST_STATUS		EQU	01h
BDSK_READ_SECTORS		EQU	02h
BDSK_WRITE_SECTORS		EQU	03h
BDSK_VERIFY_SECTORS		EQU	04h
;;BDSK_FORMAT_TRACK		EQU	05h
;;BDSK_GET_DRIVE_PARAMS		EQU	08h
;;BDSK_RESET_HARD_DISKS		EQU	0Dh
;;BDSK_CHECK_READY		EQU	10h
;;BDSK_GET_DISK_TYPE		EQU	15h
;;BDSK_DETECT_DISK_CHANGE	EQU	16h
BDSK_CHECK_EXTENSIONS		EQU	41h
BDSK_CHECK_EXTENSIONS_MAGIC	EQU	55AAh
BDSK_EXT_READ_SECTORS		EQU	42h
BDSK_EXT_WRITE_SECTORS		EQU	43h
BDSK_EXT_VERIFY_SECTORS		EQU	44h
BDSK_EXT_LOCK_DRIVE		EQU	45h
BDSK_EXT_EJECT_MEDIA		EQU	46h
BDSK_EXT_SEEK			EQU	47h
BDSK_EXT_GET_DRIVE_PARAMS	EQU	48h
BDSK_EXT_DETECT_MEDIA_CHANGE	EQU	49h

LOADER_PRODUCTBUILD  		EQU	71
LOADER_MAGIC_VALUE		EQU	4321h

MAX_SIZE			equ	260

seg1		segment byte 'code'
assume		cs:seg1, ds:seg1, es:seg1, ss:seg1

	ORG	100h
start	proc 	far
	jmp	start1
		; reserved for the end of own path buffer
		db	MAX_SIZE - 256 - 3 dup (?)

dllHandle 	dw 	0  ; return value of Register Module, used by Dispatch
oldinttable:
oldint21h 	dd 	?
oldint13h 	dd 	?
oldint25h 	dd 	?
oldint26h 	dd 	?

	assume	cs:seg1, ds:nothing, es:nothing, ss:nothing
;;
;; strcpy- Copies string pointed at by ds:si to string pointed at by es:di.
;;
;; inputs:
;;		ds:si-	Zero-terminated source string.
;;		es:di-  Buffer for destination string.
;;
;; outputs:	ds:si-	Points to end of source string.
;; 		es:di-	Points to end of destination string.
;;
;; Note: The destination buffer must be large enough to hold the string and
;;	zero terminating byte.
;;
strcpy	proc	near
		push	ax
		push	cx
		pushf
		push	es
		push	di

		cld
		mov	di, si
		push	ds
		pop	es
		xor	al, al
		mov	cx, 0ffffh
	repne	scasb
		neg	cx
		pop	di
		pop	es
		dec	cx
		shr	cx, 1
		jnc	CpyWrd
		movsb
CpyWrd:	rep	movsw
;
DidByte:
		popf
		pop	cx
		pop	ax
		ret
strcpy		endp

int21Handler proc far
;;	EAX is not saved
	pushf
	dispatchh SET_DEFAULT_DRIVE	     , SetDefaultDrive
	dispatchh GET_DISK_FREE_SPACE	     , lfnfuncGeneric
	jb	orginal
	dispatchh SET_CURRENT_DIRECTORY       , SetCurDir
	dispatch W95_GET_COMPRESSED_FILE_SIZE		, lfnfuncGeneric
	dispatch W95_EXT_LENGTH_FILENAME_OPERATIONS     , lfnfuncGeneric
	dispatch W95_LOCK_DRIVE 	     , lfnfuncIOctl
	dispatch GET_LAST_ACCESS_DATE	     , lfnfuncGetDate
	dispatch SET_LAST_ACCESS_DATE	     , lfnfuncSetDate
	dispatch GET_CREATION_DATE	     , lfnfuncGetDate
	dispatch SET_CREATION_DATE	     , lfnfuncSetDate
	dispatch LONG_RESET_DRIVE	     , lfnfuncResetDrive
	dispatch LONG_CREATE_DIRECTORY       , lfnfuncGeneric
	dispatch LONG_REMOVE_DIRECTORY       , lfnfuncGeneric
	dispatch LONG_SET_CURRENT_DIRECTORY  , lfnfuncSetCurDir
	dispatch LONG_DELETE_FILE            , lfnfuncGeneric
	dispatch LONG_GET_SET_FILE_ATTR      , lfnfuncGeneric
	dispatch LONG_GET_CURRENT_DIRECTORY  , lfnfuncGetCurDir
	dispatch LONG_FIND_FIRST             , lfnfuncGeneric
	dispatch LONG_FIND_NEXT              , lfnfuncGeneric
	dispatch LONG_RENAME_FILE            , lfnfuncGeneric
	dispatch LONG_TRUENAME               , lfnfuncGeneric
     	dispatch LONG_CREATE_FILE            , lfnfuncCreateFile
	dispatch LONG_GET_VOLUME_INFORMATION , lfnfuncGeneric
	dispatch LONG_FIND_CLOSE             , lfnfuncGeneric
	dispatch LONG_FIND_NEXT_EXT          , lfnfuncGeneric
	dispatch LONG_RESERVED_1             , lfnfuncGeneric
	dispatch LONG_RESERVED_2             , lfnfuncGeneric
	dispatch LONG_RESERVED_3             , lfnfuncGeneric
	dispatch LONG_GET_FILE_INFORMATION   , lfnfuncGerFileInformation
	dispatch LONG_CONVERT_TIME    	     , lfnfuncGeneric
	dispatch LONG_GENERATE_SHORT_NAME    , lfnfuncGeneric
	dispatch LONG_SERVER_CREATE_FILE     , lfnfuncCreateFile
	dispatch LONG_HANDLE_SUBST           , lfnfuncGeneric
	dispatch W95_GET_EXT_FREE_DRIVE_SPACE, lfnfuncGeneric
	dispatch W95_EXT_ABSOLUTE_DISK_READ_WRITE, lfnfuncGeneric

	dispatch LFNSRV_API	             , lfnSrvApi
orginal:
	popf
        jmp 	[oldint21h]	; jump to DOS interrupt dispatch handler

lfnfuncIOctl:
	cmp	ch, W95_LOCK_DRIVE_CATEG_DISK
	je	lfnfuncIOctl2
	cmp	ch, W95_LOCK_DRIVE_CATEG_FAT32_DISK
	jne	orginal
lfnfuncIOctl2:
	cmp	cl, W95_LOCK_DRIVE_MINOR_LOCK_LOGICAL
	je	lfnfuncGeneric
	cmp	cl, W95_LOCK_DRIVE_MINOR_LOCK_PHYSICAL
	je	lfnfuncGeneric
	cmp	cl, W95_LOCK_DRIVE_MINOR_UNLOCK_LOGICAL
	je	lfnfuncGeneric
	cmp	cl, W95_LOCK_DRIVE_MINOR_UNLOCK_PHYSICAL
	je	lfnfuncGeneric
	cmp	cl, W95_LOCK_DRIVE_MINOR_LOCK_GETFLAGS
	je	lfnfuncGeneric
	cmp	cl, W95_LOCK_DRIVE_MINOR_LOCK_GETSTATE
	jne	lfnfuncGeneric

lfnfuncGeneric:
	popf
	push	DOS_INTR
	call_vdd
	ret 	2

lfnfuncGetDate:
lfnfuncGerFileInformation:
lfnfuncSetDate:
;;	on call to vdd
;;	BX = file handle
;;      ES:DI = JFT
;;
;;	additionally on GET_DATE calls
;;      	ECX = PDP
;;	additionally on GET_FILE_INFO call
;;      	ECX = PDP
;;		DS:DX = buffer
;;	additionally on SET_DATE calls
;;		right part of ECX = PDP
;;		left part of ECX (==CX) = time
;;		DX = date
;;
	popf
  	cmp	ax, SET_LAST_ACCESS_DATE
	je	dont_zero_cx
	cmp	ax, SET_CREATION_DATE
	je	dont_zero_cx
	xor	cx, cx
dont_zero_cx:
	push	ax
	push	bx
	mov	ah, GET_CURRENT_PSP
	pushf
	call	[oldint21h]	;;BX=PSP segment
	mov	ax, cx
	mov	cx, bx
	mov	es, bx
	mov	di, es:[34h]
	mov	es, es:[36h]	;;ES:DI = JFT
.386
	shl	ecx, 16
.8086
	mov	cx, ax		;;ECX = PSPseg:Time
	pop	bx		;;BX = file handle
	pop	ax		;;function code
	push	DOS_INTR
	call_vdd
	ret 	2

lfnfuncResetDrive:
	popf
	mov	ah, RESET_DRIVE
	pushf
        call 	[oldint21h]	;
	clc
	ret 	2

SetCurDir:
lfnfuncSetCurDir:
	popf
;;	ds:dx points to the pathname
	push	es
	push	si
	push	di
	push	ds
	push	dx
;;	copy path to own buffer
	mov	si, dx
	push	cs
	pop	es
	mov	di, offset set_dir_buffer
	push	es
	push	di
	call	strcpy
	pop	dx
	pop	ds
;;	call VDD to convert all path components to short form in own buffer
	push	DOS_INTR
	call_vdd
	jc	bad_1
;;	change short current directory to short path in own buffer
	mov	AH, SET_CURRENT_DIRECTORY
	pushf
        call 	[oldint21h]	;

bad_1:
	pop	dx
	pop	ds
	pop	di
	pop	si
	pop	es
	ret 2

lfnfuncGetCurDir:
	popf
	mov	ah, GET_CURRENT_DIRECTORY
	PUSHF
	call	[oldint21h]
	jc	bad
	or	dl, dl
	jnz	skip_drive
	mov	ah, GET_CURRENT_DRIVE
	pushf
	call	[oldint21h]
	jc	bad
	mov	dl, al
	add	dl, 64d			;;40h
skip_drive:
	mov	ax, LONG_GET_CURRENT_DIRECTORY
	push	DOS_INTR
	call_vdd
	ret 	2

lfnfuncCreateFile:
;;	WORD nMode    = getBX();
;;	WORD nAttrs   = getCX();
;;	WORD nAction  = getDX();
;;	WORD nAlias   = getDI();
;;	ULONG Address = MAKEADDRESS(getDS(), getSI());
	popf
	push	es
	push	si
	push	di
	push	ds
	push	dx
;;	copy path to own buffer
	push	cs
	pop	es
	mov	di, offset create_file_buffer
	push	es
	push	di
	call	strcpy
	pop	si
	pop	ds
;;	call VDD to convert all path components to short form in own buffer
	push	DOS_INTR
	call_vdd
	jc	bad_2
	or	ax, ax
	jz	nofileoperation_2
;;	create file with short path in own buffer
;;;;	mov	ax, CREATE_OPEN_FILE
	pushf
        call 	[oldint21h]	;
bad_2:
nofileoperation_2:
	pop	dx
	pop	ds
	pop	di
	pop	si
	pop	es
	ret 2

SetDefaultDrive:
;;	Sets default drive
;;
;;	first call original dos function
;;	then get default directory
;;	then act as if you called SetDirectory for that drive
;;
	popf
	pushf
        call 	[oldint21h]	;set default drive
	cmp	dl, al
	ja	no_change
	push	dx		;0=A, 1=B, 2=C
	push	ax
	push	ds
	push	si
	mov     ax, cs
	mov	ds, ax
	mov	si, offset set_dir_buffer
	mov	al, dl
	add	al, 'A'
	mov	byte ptr ds:[si  ], al
	mov	byte ptr ds:[si+1], ':'
	mov	byte ptr ds:[si+2], '\'
	mov	byte ptr ds:[si+3],  0
	add	si, 3
	add	dl, 1                   ;1=A, 2=B
	mov	ah, GET_CURRENT_DIRECTORY
	pushf
        call 	[oldint21h]	;get default directory
	mov	dx, offset set_dir_buffer
	mov	ax, LONG_SET_CURRENT_DIRECTORY
	pushf
	push	DOS_INTR
	call_vdd
	popf

	pop	si
	pop	ds
	pop	ax
	pop	dx
no_change:
	ret 	2

lfnSrvApi:
	cmp	BX, LFNSRV_GET_LOADER_INFO
	je	get_loader_info
	cmp	BX, LFNSRV_SET_SFT_INFO
	je	lfnfuncGeneric
	jmp	orginal
get_loader_info:
	popf
;;	AX = handle
;;	BX = buildinfo
;;	CX = magic value
;;	ds:ds old interrupt entries
	mov	ax, [dllHandle]
	mov	bx, LOADER_PRODUCTBUILD
	mov	cx, LOADER_MAGIC_VALUE
	push	cs
	pop	ds
	lea	dx, oldinttable
bad:
nofileoperation:
	ret 	2
int21Handler endp

int13Handler proc far
	pushf
;;	dispatchh BDSK_GET_DRIVE_PARAMS		, BdskGeneric
;;	dispatchh BDSK_RESET_HARD_DISKS		, BdskGeneric
;;	dispatchh BDSK_CHECK_READY		, BdskGeneric
;;	dispatchh BDSK_GET_DISK_TYPE		, BdskGeneric
;;	dispatchh BDSK_DETECT_DISK_CHANGE	, BdskGeneric
;;	dispatchh BDSK_CHECK_READY		, BdskGeneric
	cmp	ah, BDSK_READ_SECTORS
	jb	BdskOriginal
	cmp	ah, BDSK_VERIFY_SECTORS
	jbe	BdskGeneric
	cmp	ah, BDSK_CHECK_EXTENSIONS
	jb	BdskOriginal
	cmp	ah, BDSK_EXT_DETECT_MEDIA_CHANGE
	jbe	BdskGeneric

BdskOriginal:
	popf
	jmp 	[oldint13h]

BdskGeneric:
	popf
	push	BIOS_DISK_INTR
	call_vdd
	ret 	2
int13Handler endp

int25Handler proc far
	push	ABS_DISK_READ_INTR
	call_vdd
	ret	; don't pop flags off the stack
;;;;	jmp 	[oldint25h]
int25Handler endp

int26Handler proc far
	push	ABS_DISK_WRITE_INTR
	call_vdd
	ret
;;;;	jmp 	[oldint26h]
int26Handler endp

;; define file name buffers into PSP (CS:0)
set_dir_buffer		equ	0
create_file_buffer	equ	0
;;set_dir_buffer	db	MAX_SIZE dup (?)
;;create_file_buffer	db	MAX_SIZE dup (?)

resident_end:

message1 	db 	'Long filename API services for Windows NT 0.81.71',13,10
           	db	'Copyright (C) 1997-2000 Wojciech Galazka, Andrew Crabtree,',13,10
           	db	'  2016 Joe Forster/STA',13,10
		db	'Released under the terms of the GNU General Public License',13,10
           	db	'The software comes with NEITHER IMPLIED NOR EXPRESSED WARRANTY',13,10
		db	'to the extent permitted by law',13,10,'$'

error_nt4req	db 	'ERROR: MS Windows NT 4.0 is required to run this program$'
error_dll	db 	'ERROR: Module not found$'
error_dispatch 	db 	'ERROR: Dispatch routine not found$'
error_init	db 	'ERROR: Initialization routine not found$'
error_outofmem	db 	'ERROR: Out of memory, terminating$'
error_unknown 	db 	'ERROR: Unknown error$'
dll_errors	dw	error_dll, error_dispatch, error_init, error_outofmem, error_unknown
wrongversion	db	'ERROR: DLL & COM file version mismatch$'
terminating	db	', terminating ...',13,10,'$'
registered 	db 	'SUCCESS: Long filename API services installed',13,10,'$'
unregister	db 	'SUCCESS: Long filename API services uninstalled.',13,10,'$'
startmsg 	db 	'Searching module ... ','$'
dllName 	db 	'lfnsrv.dll',0;
		db	13,10,'$'
dllDispatch 	db	'LFNDispatch',0;
		db	13,10,'$'
dllInitialize 	db 	'LFNRegisterInit',0;
		db	13,10,'$'

	assume	cs:seg1, ds:seg1, es:seg1, ss:seg1

start1:					; CS=DS=ES
	push	cs
	pop	ds
	print 	message1

	; check presence of Windows NT
	MOV   	AX, GET_TRUE_VERSION_NUMBER
	INT   	DOS_INTR
	CMP	BX,   3205H
	JE	check_lfn_presence

	print	error_nt4req
        jmp 	Terminate2

check_lfn_presence:
	print	startmsg
	print	dllName

	;check if lfnsrv already running
	mov	ax, LFNSRV_API
	mov	bx, LFNSRV_GET_LOADER_INFO
	int	DOS_INTR
	cmp	cx, LOADER_MAGIC_VALUE
	;lfn services not running
	jne	install_lfn

;;	restore interrupt
	mov	[dllHandle], ax
	mov	di, dx
	push	ds
	pop	es
	lds	dx, es:[di]
        mov 	ah, SET_INTERRUPT_VECTOR
        mov 	al, DOS_INTR           	; DOS Handler
;;	ds:dx points to the original int 21 routine
        int 	DOS_INTR
        add	di, 4
	lds	dx, es:[di]
        mov 	al, BIOS_DISK_INTR
        int 	DOS_INTR
        add	di, 4
	lds	dx, es:[di]
        mov 	al, ABS_DISK_READ_INTR
        int 	DOS_INTR
        add	di, 4
	lds	dx, es:[di]
        mov 	al, ABS_DISK_WRITE_INTR
        int 	DOS_INTR
	mov	ax, [dllHandle]
        VDDUnregister

 	push	cs
	pop	ds
	print	unregister
        jmp 	Terminate

install_lfn:
	stc
;;	register Our DLL - From VDD guide for Application Based Intercepts
	mov 	ax, 0
	mov 	si, offset dllName          	;dll name
	mov 	di, offset dllInitialize	;init routine
	mov 	bx, offset dllDispatch	 	;dispatch routine
	VDDRegister
	jnc	registerOK

registerError:
	dec	ax
	cmp	ax, 4
	jbe	printRegError
	mov	ax, 4
printRegError:
	mov	bx, ax
	shl	bx, 1
	mov 	dx, dll_errors[bx]
	mov 	ah,  DISPLAY_STRING
	int 	DOS_INTR
Terminate2:
	print	terminating

Terminate:
        mov 	ah, TERMINATE_PROGRAM
        xor 	al, al               	; Return Code
	int 	DOS_INTR

registerOK:
        mov 	[dllHandle], ax

	;check for version
	mov	ax, LFNSRV_API
	mov	bx, LFNSRV_GET_VERSION_INFO
	push	DOS_INTR
	call_vdd
	cmp	bx, LOADER_PRODUCTBUILD
	je	installIRQ

	mov	ax, [dllHandle]
        VDDUnregister
	print	wrongversion
        jmp 	Terminate2

installIRQ:
;;	but first set info about SFT
;;	get SFT
	mov	ah, GET_SYSVARS_TABLE
	int	DOS_INTR		;;ES:BX points to "SysVars" table
;;;;	assume es:nothing
	mov	di, es:[bx+04h]
	mov	es, es:[bx+06h]	;;now SFT in ES:DI

	mov	ax, LFNSRV_API
	mov	bx, LFNSRV_SET_SFT_INFO
	push	DOS_INTR
	call_vdd

        print	registered
        mov 	ah, GET_INTERRUPT_VECTOR
        mov 	al, DOS_INTR
        int 	DOS_INTR
        mov 	WORD PTR [oldint21h],bx
        mov 	WORD PTR [oldint21h+2], es
        mov 	al, DOS_INTR
        int 	DOS_INTR
        mov 	WORD PTR [oldint13h],bx
        mov 	WORD PTR [oldint13h+2], es
        mov 	al, ABS_DISK_READ_INTR
        int 	DOS_INTR
        mov 	WORD PTR [oldint25h],bx
        mov 	WORD PTR [oldint25h+2], es
        mov 	al, ABS_DISK_WRITE_INTR
        int 	DOS_INTR
        mov 	WORD PTR [oldint26h],bx
        mov 	WORD PTR [oldint26h+2], es
        mov 	ah, SET_INTERRUPT_VECTOR
        mov 	al, DOS_INTR
;;;;	push	cs
;;;;	pop	ds
        mov 	dx, offset int21Handler;
        int 	DOS_INTR
        mov 	al, BIOS_DISK_INTR
        mov 	dx, offset int13Handler;
        int 	DOS_INTR
        mov 	al, ABS_DISK_READ_INTR
        mov 	dx, offset int25Handler;
        int 	DOS_INTR
        mov 	al, ABS_DISK_WRITE_INTR
        mov 	dx, offset int26Handler;
        int 	DOS_INTR

        ;; Terminate and stay resident now

	mov	es, cs:[2Ch]
	mov	ah, FREE_ENVIRONM_MEMORY
	int   	DOS_INTR
        mov 	ah, GO_STAY_TSR		; TSR
        xor 	al, al               	; Return Code
        mov 	dx, offset resident_end+15
	mov	cl, 4
	shr	dx, cl
        int 	DOS_INTR
start	endp
seg1	ends
	end	start
